clear all
close all

s = RandStream('mcg16807','Seed',121121); RandStream.setDefaultStream(s);

%load benchmarks.mat;

% Boosting round
MaxIter = 150;

% noise rate
nr = 0.0;

for i=1:10 % repetitions
    
    %Donut data set
    [Xt yt fd Xs ys fds] = genData(1, 2, 500, 100, 3, 'gen');
    
    idx = find(sqrt(Xt(:,1).^2 + Xt(:,2).^2)<1);
    yt(idx) = -1;
    idx = find(sqrt(Xs(:,1).^2 + Xs(:,2).^2)<1);
    ys(idx) = -1;   

    %% Adding noise        
    [yz fdz] = injectLabelNoise(yt, [nr 0]);  % the function return label in {1,2}
    yz = castLabel(yz,-1);
    
    
    % predefined correct gamma table
    true_gamma = [1-nr nr; 0 1];
    
           
%     % rLR + AdaBoost
%     opt12.round   = MaxIter; 
%     opt12.verbose = false;
%     opt12.estG    = false;
%     opt12.bType   = 'ada';
%     opt12.learner = 'rlr';
%     opt12.gamma   = eye(2);  
%     
%     [a12 h12]        = gBoost(Xt, yz, opt12);         
%     [yh et_12(i,:)]  = gBoostClassify(a12, h12, Xt, yz);  % training error
%     [yh er_12(i,:)]  = gBoostClassify(a12, h12, Xs, ys);  % test error    
%     fprintf('%s+%s=%.3f , ', opt12.bType, opt12.learner, er_12(i,end)); 
 

%     % rLR + Goada + Fixed gamma
%     opt22.round   = MaxIter;
%     opt22.verbose = true;
%     opt22.estG    = false;
%     opt22.learner = 'rlr';
%     opt22.bType   = 'goada';
%     opt22.gamma   = true_gamma;
%      
%     [a22 h22]        = gBoost(Xt, yz, opt22);          
%     [yh et_22(i,:)]  = gBoostClassify(a22, h22, Xt, yz);   % training error
%     [yh er_22(i,:)]  = gBoostClassify(a22, h22, Xs, ys);   % test error
%     fprintf('%s+%s=%.3f , ', opt22.bType, opt22.learner, er_22(i,end)); 
    

    % rLR + Goada + Estimated gamma
    opt32.round   = MaxIter;
    opt32.verbose = true;
    opt32.estG    = true;
    opt32.pType   = 'platt';
    opt32.learner = 'rlr';
    opt32.bType   = 'goada';
    opt32.gamma   = [.8 .2;.2 .8];
     
    [a32 h32]        = gBoost(Xt, yz, opt32, Xt,yz);          
    [yh et_32(i,:)]  = gBoostClassify(a32, h32, Xt, yz);   % training error
    [yh er_32(i,:)]  = gBoostClassify(a32, h32, Xs, ys);   % test error
    fprintf('Error for %s+%s+%s=%.6f , ', opt32.bType, opt32.learner, opt32.pType, er_32(i,end)); 
    

    
    fprintf('\n');    
end % end experiment repetition


%% Summarising result of the dataset of the noiseType at the noiseRate
erall   = who('er_*');
etall   = who('et_*');
optall  = who('opt*');

for m=1:length(erall)
    c_opt = eval(optall{m});
    c_er  = eval(erall{m});
%     if c_opt.estG
%         fprintf('%s+%s+%s=%.3f , ', c_opt.bType, c_opt.learner, ...
%                                     c_opt.pType, mean(c_er(:,end)));  
%     else
        fprintf('& %.3f$\\pm$%.2f ', mean(c_er(:,end))*100,std(c_er(:,end))*100);
%     end    
%     if mod(m,3)==0
%         fprintf('\n');
%     end
end
fprintf('\n');
fprintf('-----------------------------------------------------------------\n');

% % save some variables
% filename = sprintf('%s_%s_%d_longiter', dataset, nt, nr*100);
% save(filename,'nt','nr', 'dataset','MaxIter',erall{:},etall{:},optall{:});
% % clear the working space
% clear(erall{:},etall{:},optall{:});

