% function definition for 'minFunc' optimiser
% fv  = function value
% dfv = gradient of the function w.r.t W

function [fv dfv] = grad_a_isd(a, D, y, gamma, ep, en)

fvp = (exp(a*(1-gamma(1,2))) - exp(-a*(1-gamma(1,2))))*ep + sum(D.*(y==1).*exp(-a*(1-gamma(1,2))));
fvn = (exp(a*(1-gamma(2,1))) - exp(-a*(1-gamma(2,1))))*en + sum(D.*(y==-1).*exp(-a*(1-gamma(2,1))));

fv  = fvp + fvn;

dfvp = ((1-gamma(1,2))*exp(a*(1-gamma(1,2))) + (1-gamma(1,2))*exp(-a*(1-gamma(1,2))))*ep ...
       + (sum(-(1-gamma(1,2)) * D.*(y==1).*exp(-a*(1-gamma(1,2)))));
dfvn = ((1-gamma(2,1))*exp(a*(1-gamma(2,1))) + (1-gamma(2,1))*exp(-a*(1-gamma(2,1))))*en ...
       + (sum(-(1-gamma(2,1)) * D.*(y==-1).*exp(-a*(1-gamma(2,1)))));
   
dfv = dfvp + dfvn;