% function definition for 'minFunc' optimiser
% fv  = function value
% dfv = gradient of the function w.r.t W

function [fv dfv] = grad_a_osd(a, d11, d01, d10, d00, gamma, e)

t1  = (sum(gamma(2,2)*d11) + sum(gamma(1,1)*d00)) / exp(a);
t2  = (sum(gamma(1,2)*d01) + sum(gamma(2,1)*d10)) * exp(a);

fv  = (2*sinh(a) * e) + t1 + t2;
dfv = (2*cosh(a) * e) - t1 + t2;
 