function [yHat, err] = logitBoostClassify(h,x,y)

Fx = 0; % final classification {class(sign)+confidence}

for i=1:size(h,2)

    fx  =  addbias(x) * h(:,i);       
    Fx  =  Fx + 0.5.*fx;
    
    F_num = exp(Fx);
    % --- control
    idx = F_num == inf;
    if any(idx == 1)
        F_num(idx) = realmax;
    end
    F_den =  (exp(Fx)+exp(-Fx));
    % --- control
    idx = F_den == inf;
    if any(idx == 1)
        F_den(idx) = realmax;
    end
    p        = F_num./F_den; % probability of x being in class 1
    p(p < 0) = 0;

    % output
    yHat(p >  .5,1) = 1;
    yHat(p <= .5,1) = -1;
    
    err(i) = sum(y ~= yHat)/length(y);

end

